module Envoi
  module Mam
    class Agent

      class BaseDaemon

        attr_accessor :logger, :initial_args

        def initialize(*args)
          @initial_args = args
        end

        # Processes a hash and creates instance variables for each key set to it's corresponding value
        # If args is an array then it processes the first hash it comes to in that array (Good for passing *args from a previous method)
        #
        # @param args (Hash|Array|nil) The hash or array to process
        def set_instance_variables(args = nil)
          _args = args
          _args = _args.find { |v| v.is_a? Hash } if _args.is_a? Array
          _args.each { |key, val| instance_variable_set("@#{key}", val) } if _args.is_a? Hash
        end

      end

      # Agent
    end

    # Mam
  end

  # Envoi
end
