#! /usr/bin/env ruby
# Installation
# `gem install aws-sdk-s3`
#
require 'net/https'
require 'json'
require 'optparse'
require 'pp'
require 'csv'

ARGV << '--help' if ARGV.empty?
args = {
    show_summary: true,
    eis_url: 'https://ksbw8ud7v6.execute-api.us-east-1.amazonaws.com/stage/createmcjob',
    s3_object_key_prefix: '',
    preview_only: false
}
op = OptionParser.new
op.on('--bucket-name [BUCKETNAME]', 'The bucket to get objects from.') { |v| args[:s3_bucket_name] = v }
op.on('--key-prefix [KEYPREFIX]', 'The object key prefix to limit the results by.', 'default: /') { |v| args[:s3_object_key_prefix] = v }
op.on('--aws-access-key [KEY]', '') { |v| args[:aws_access_key_id] = v }
op.on('--aws-secret-key [KEY]', '') { |v| args[:aws_secret_access_key] = v }
op.on('--aws-profile [PROFILENAME]', '') { |v| args[:aws_profile] = v }
op.on('--aws-region [REGION]', 'The AWS region what the bucket is located.', 'default: auto-detected') { |v| args[:aws_region] = v }
op.on('--limit [LIMIT]', 'Limit the number of results.', 'default: unlimited') { |v| args[:limit] = v }

op.on('--[no-]preview', 'Output paths with summary and stop.',
      "default: #{args[:preview_mode] ? 'true' : 'false'}") { |v| args[:preview_only] = v }
op.on('--[no-]summary', 'Output the paths and calculate the number of assets.',
      "default: #{args[:show_summary] ? 'true' : 'false'}",) { |v| args[:show_summary] = v }

op.on('-h', '--help', 'Print help (this message) and exit') { puts op; exit }
op.parse!




s3_enum = S3Enumerator.new(args)
s3_enum.run
exit if args[:preview_only]
s3_enum.process_files do |object|

end



