#!/usr/bin/env ruby
lib_path = __FILE__ == '(irb)' ? File.join(Dir.cwd, 'lib') : File.expand_path('../../../lib', __FILE__)
$:.unshift(lib_path) unless $:.include?(lib_path) or !File.exists?(lib_path)
require 'rubygems'

require 'envoi/mam/agent/cli'
require 'envoi/mam/vdms/agent'

current_command = ARGV.shift
ARGV << '--help' if ARGV.empty?

args = {
    :config_file_path => default_config_file_paths,
    :dry_run => false,
    :preserve_path => true,
    :destination_path => File.expand_path('.'),
}

args[:config_service_app_id] = ENV['ENVOI_MAM_AGENT_APP_ID']
args[:config_service_app_token] = ENV['ENVOI_MAM_AGENT_APP_TOKEN']
args[:config_service_app_url] = ENV['ENVOI_MAM_AGENT_APP_URL']

op = OptionParser.new
op.on('-c', '--config-file-path FILEPATH', 'The path to the configuration file.') { |v| args[:config_file_path] = v }
op.on('--agent-app-id ID', '') { |v| args[:config_service_app_id] = v }
op.on('--agent-token TOKEN', '') { |v| args[:config_service_app_token] = v }
op.on('--agent-service-api URL', '') { |v| args[:config_service_api_url] = v }

op.on('-d', '--destination-path DIRPATH', 'The destination path to download or upload to.', "default: '#{args[:destination_path]}'") { |v| args[:destination_path] = v }
op.on('-p','--[no-]preserve-path', "default: #{args[:preserve_path]}") { |v| args[:preserve_path] = v }

# op.on('--dry-run', 'Run without executing the transfer.') { |v| args[:dry_run] = v }
op.on('--help', 'Show this message.') { puts op; exit }
op.load
op.parse!

args[:file_path] ||= ARGV.shift
args[:destination_path] ||= ARGV.shift unless ARGV.empty?

agent = Envoi::Mam::Vdms::Agent.load_config_and_init(args)
agent.run_operation
